import "antd/es/form/style";
import _Form from "antd/es/form";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

import * as React from "react";
import { isFn, isPromise, isObj, isArr } from "../utils/tool";
import renderOptions from "../lib/renderOptions";
import compMap from "../SCompMap/compMap";
import { compDidMount } from "../hooks/lifeCycle";
var useState = React.useState,
    useEffect = React.useEffect;
var defaultItemWidth = {
  RangePicker: 400
};
export default function SForm(_a) {
  var initialData = _a.initialData,
      filters = _a.filters,
      formProps = _a.formProps,
      formChange = _a.onChange,
      onFormDataChange = _a.onFormDataChange,
      updateFormData = _a.updateFormData,
      asFormChildren = _a.asFormChildren,
      getInnerApi = _a.getInnerApi;

  var _b = useState({}),
      formData = _b[0],
      setFormData = _b[1];

  useEffect(function () {
    setFormData(__assign({}, initialData)); // 动态依赖initialData
  }, [initialData]);

  var _c = useState({}),
      itemChildren = _c[0],
      setItemChildren = _c[1];

  var filterItemChange = function (v, key, onChange) {
    var _a;

    if (v && v.target) v = v.target.value;

    var res = __assign({}, formData, (_a = {}, _a[key] = v, _a));

    setFormData(res);
    if (isFn(onChange)) onChange(v);
    if (isFn(formChange)) formChange(__assign({}, res));
  };

  useEffect(function () {
    isFn(updateFormData) && updateFormData(formData);
    isFn(onFormDataChange) && onFormDataChange(__assign({}, formData));
  }, [formData]);
  var formItems = filters.map(function (_a) {
    var Comp = _a.Comp,
        _b = _a.type,
        type = _b === void 0 ? "Input" : _b,
        label = _a.label,
        key = _a.key,
        formItemProps = _a.formItemProps,
        render = _a.render,
        onChange = _a.onChange,
        options = _a.options,
        _c = _a.style,
        style = _c === void 0 ? {} : _c,
        props = _a.props,
        required = _a.required;
    style.width = defaultItemWidth[type] || 300;
    var Item = compMap[type];
    compDidMount(function () {
      var _a;

      getInnerApi({
        setFormData: setFormData
      });
      var Children = render && render();
      if (options) return;

      if (isPromise(Children)) {
        Children.then(function (Child) {
          var _a;

          if (isObj(Child) || isArr(Child) && Child[0].label && Child[0].value) Child = renderOptions(Child);
          setItemChildren(__assign({}, itemChildren, (_a = {}, _a[key] = Child, _a)));
        }).catch(function (err) {
          console.log("get " + key + " options error :" + err);
        });
      } else {
        setItemChildren(__assign({}, itemChildren, (_a = {}, _a[key] = Children, _a)));
      }
    });
    return Item ? React.createElement(_Form.Item, __assign({
      required: required,
      key: label,
      label: label
    }, formItemProps), Comp ? isFn(Comp) ? React.createElement(Comp, null) : Comp : React.createElement(Item, __assign({
      allowClear: !required,
      value: formData[key],
      onChange: function (e) {
        filterItemChange(e, key, onChange);
      },
      style: style
    }, props), options ? renderOptions(options) : itemChildren[key])) : null;
  });
  return asFormChildren ? formItems : React.createElement(_Form, __assign({
    layout: "inline"
  }, formProps), formItems);
}
SForm.defaultProps = {
  filters: [],
  initialData: {}
};