import React, { useState } from "react";
import ReactDOM from "react-dom";
import "antd/dist/antd.css";
import SPage from "../src/index";
import { message } from "antd";
const formItemProps = {
  style: {
    height: 40
  }
};
const initialData = {
  age: 18
};
const tableData: any = [];
for (let i = 0; i < 100; i++) {
  tableData.push({
    id: i,
    age: i
  });
}
let innerRefCurrent;
const App = () => {
  const options = {
    url: "/api",
    resetForm: true,
    initialSearch: false,
    innerApi(refCurrent) {
      innerRefCurrent = refCurrent;
    },
    filters: [
      {
        type: "RangePicker",
        label: "createTime",
        key: "ctime",
        props: {
          showTime: false
        }
      },
      {
        label: "Age",
        key: "age",
        formItemProps,
        tableColumn: {
          defaultSortOrder: "descend",
          sortDirections: ["descend", "ascend", "descend"],
          sorter: (a, b) => a.age - b.age
        }
      },
      {
        type: "Select",
        label: "Status",
        key: "status",
        formItemProps,
        render() {
          return new Promise(rs => {
            setTimeout(() => {
              rs({ 0: "doing", 1: "done" });
            }, 2000);
          });
        }
      }
    ],
    buttons: [
      {
        label: "GetList",
        handler() {
          return innerRefCurrent.fetchTableList({ abc: 123, d: 132 });
        }
      }
    ],
    tableData,
    tableColumns: [
      {
        title: "Action",
        buttons: [
          {
            label: "showModal",
            modalRender(row) {
              return <p style={{ height: 100 }}>{row.age}</p>;
            }
          }
        ]
      }
    ],
    rowKey: "id",
    tableProps: {
      scroll: { x: true }
    },
    paginationProps: {
      showSizeChanger: true,
      pageSizeOptions: ["10", "20", "50"]
    }
  };

  return (
    <div>
      <SPage initialData={initialData} {...options}></SPage>
    </div>
  );
};

ReactDOM.render(<App></App>, document.getElementById("app"));
