import * as React from "react";
import { Form, Card } from "antd";
import { isFn } from "../utils/tool";
import SButton from "./SButton";
import SForm from "./SForm";
let _setFormData: any;
export default function SFilter({
  formProps,
  buttons,
  searchLoading,
  searchHandler,
  resetForm,
  ...rest
}: any) {
  const reset = () => {
    if (_setFormData) _setFormData({});
  };
  const getInnerApi = ({ setFormData }: any) => {
    _setFormData = setFormData;
  };
  return (
    <Card>
      <Form layout="inline" {...formProps}>
        <SForm getInnerApi={getInnerApi} asFormChildren={true} {...rest} />
        <Form.Item>
          {
            <SButton
              handler={searchHandler}
              label="Search"
              type="primary"
              loading={searchLoading}
              props={{
                htmlType: "submit"
              }}
            />
          }
          {resetForm && (
            <SButton style={{ marginLeft: 10 }} label="Reset" handler={reset} />
          )}
          {buttons.map(({ Comp, label, key, ...rest }: any) => {
            if (Comp) {
              return isFn(Comp) ? <Comp key={key} /> : Comp;
            }
            return (
              <SButton
                style={{ marginLeft: 10 }}
                key={label}
                label={label}
                {...rest}
              />
            );
          })}
        </Form.Item>
      </Form>
    </Card>
  );
}
SFilter.defaultProps = {
  buttons: []
};
