import * as React from "react";
import { Table, Card } from "antd";
export default function STable({
  tableData,
  tableColumns,
  tableProps,
  paginationProps,
  pageNum = 1,
  pageSize = 10,
  totalNum = 0,
  pageChange,
  loading
}: any) {
  const pageSizeChange = (_pageNum: number, pageSize: number) =>
    pageChange(1, pageSize);
  return (
    <Card style={{ marginTop: 20 }}>
      <Table
        loading={loading}
        rowKey={tableProps.rowKey || "id"}
        dataSource={tableData}
        columns={tableColumns}
        pagination={{
          current: pageNum,
          pageSize: pageSize,
          total: totalNum,
          onChange: pageChange,
          onShowSizeChange: pageSizeChange,
          showTotal: (total: number, range: number[]) =>
            `${range[0]}-${range[1]} of ${total} items`,
          ...paginationProps
        }}
        {...tableProps}
      />
    </Card>
  );
}
STable.defaultProps = {
  tableData: [],
  tableProps: {}
};
